/* 
******************************************************
* ե̾ : win_com.c                             *
*                                                    *
* by ichikawa@landmark.fct.cs.fujitsu.co.jp          *
******************************************************
*/
#include "win_def.h"

/*  ӥåȥޥå */
#include "bitmaps/icon"

/* 
******************************************************
* ؿ̾ : init_window( s )                          *
* ǽ   : ɥν                  *
*    : struct screen_tag *s ;                    *
*  :                                           *
******************************************************
*    :                                           *
*  screen_tag ¤Τ name ˤϡǥץ쥤̾     *
*  ޤϡΣգ̣̤ꤹ뤳ȡ                  *
******************************************************
*/
init_window( s )
struct screen_tag *s;
{
XWMHints	wmh;
XSizeHints	xsh;
XColor          c1, c2, cc ;

    /*>>>>> Open Display <<<<<*/
    s->disp = XOpenDisplay( s->name );

    /*>>>>> make default color map <<<<<*/
    s->cmap = DefaultColormap( s->disp, 0 );

    /*>>>>> Create Window <<<<<*/
    s->win  = XCreateSimpleWindow( s->disp, RootWindow( s->disp, 0 ), 0, 0,
		  WIN_W, WIN_H, 2,
		  mycolor( s, WIN_FG ), mycolor( s, WIN_BG ) );

    XStoreName( s->disp, s->win, WIN_NAME );

    /*>>>>> Set Window Attributes <<<<<*/
    s->atr.backing_store = Always ;
    s->atr.bit_gravity   = CenterGravity ;

    XChangeWindowAttributes( s->disp, s->win, CWBackingStore, &(s->atr) ) ;
    XSelectInput( s->disp, s->win, ButtonPress | ButtonRelease );

    /*>>>>> Set Icon Pixmap <<<<<*/
    s->icon = XCreateBitmapFromData( s->disp, s->win,
	icon_bits, icon_width, icon_height );

    wmh.flags = IconPositionHint | IconPixmapHint ;
    wmh.initial_state = IconicState ;
    wmh.icon_x = 0 ;
    wmh.icon_y = 0 ;
    wmh.icon_pixmap = s->icon ;
    XSetWMHints( s->disp, s->win, &wmh );

    /*>>>>> Set Window size <<<<<*/
    xsh.flags = PMinSize | PMaxSize ;
    xsh.min_width  = WIN_W_MIN;
    xsh.min_height = WIN_H_MIN;
    xsh.max_width  = WIN_W_MAX;
    xsh.max_height = WIN_H_MAX;
    XSetNormalHints( s->disp, s->win, &xsh ) ;
    XMapWindow( s->disp, s->win );

    /*>>>>> Set GC, & Load Font data <<<<<*/
    s->gc_a = XCreateGC( s->disp, s->win, 0, 0 );
    s->f_a  = XLoadFont( s->disp, FONT_A );
    XSetFont( s->disp, s->gc_a, s->f_a  );

    s->gc_k = XCreateGC( s->disp, s->win, 0, 0 );
    s->f_k  = XLoadFont( s->disp, FONT_K );
    XSetFont( s->disp, s->gc_k, s->f_k  );

    return(0);
}

/* 
******************************************************
* ؿ̾ : term_window( s )                          *
* ǽ   : ɥλ롣                    *
*    : struct screen_tag *s ;                    *
*  : ˣ                                    *
******************************************************
*    :                                           *
******************************************************
*/
term_window( s ) 
struct screen_tag *s ;
{
    XDestroyWindow( s->disp, s->win ) ;

    XCloseDisplay( s->disp ) ;

    return(0);
}

/* 
******************************************************
* ؿ̾ : set_bitmap( s, bit, w, h )                *
* ǽ   : ӥåȥޥåץѥŸ롣          *
*    : struct screen_tag *s ;                    *
*          char   *bit ;                             *
*          int    w    ;                             *
*          int    h    ;                             *
*  : ŸPixmap                      *
******************************************************
*    :                                           *
******************************************************
*/
set_bitmap( s, bit, w, h )
struct screen_tag *s ;
char   *bit ;
int    w ;
int    h ;
{
    return( XCreateBitmapFromData( s->disp, s->win, bit, w, h ) );
}

/* 
******************************************************
* ؿ̾ : mycolor( s, color )                       *
* ǽ   : ǡ롣                      *
*    : struct screen_tag *s ;                    *
*          char   *color ;                           *
*  : ǡ                                  *
******************************************************
*    :                                           *
*   color ˤϡ̾ʸǻꤹ롣         *
******************************************************
*/
mycolor( s, color )
struct screen_tag *s ;
char    *color ;
{
XColor  c0, c1 ;

    XAllocNamedColor( s->disp, s->cmap, color, &c1, &c0 );
    return( c1.pixel );
}

/* 
******************************************************
* ؿ̾ : set_color_a( s, fg, bg )                  *
* ǽ   : ǣá˿ꤹ롣                  *
*    : struct screen_tag *s ;                    *
*          char   *fg ;                              *
*          char   *bg ;                              *
*  : ˣ                                    *
******************************************************
*    :                                           *
*  fg ˤϡ̿̾ꤹ롣                 *
*  bg ˤϡ̿̾ꤹ롣                 *
******************************************************
*/
set_color_a( s, fg, bg )
struct screen_tag *s ;
char    *fg ;
char    *bg ;
{
    XSetForeground( s->disp, s->gc_a, mycolor( s, fg ) );
    XSetBackground( s->disp, s->gc_a, mycolor( s, bg ) );

    return(0);
}

/* 
******************************************************
* ؿ̾ : set_color_k( s, fg, bg )                  *
* ǽ   : ǣáˤ˿ꤹ롣                  *
*    : struct screen_tag *s ;                    *
*          char   *fg ;                              *
*          char   *bg ;                              *
*  : ˣ                                    *
******************************************************
*    :                                           *
*  fg ˤϡ̿̾ꤹ롣                 *
*  bg ˤϡ̿̾ꤹ롣                 *
******************************************************
*/
set_color_k( s, fg, bg )
struct screen_tag *s ;
char    *fg ;
char    *bg ;
{
    XSetForeground( s->disp, s->gc_k, mycolor( s, fg ) );
    XSetBackground( s->disp, s->gc_k, mycolor( s, bg ) );

    return(0);
}

/* 
******************************************************
* ؿ̾ : make_button( s, b )                       *
* ǽ   : ܥɽ롣                  *
*    : struct screen_tag *s ;                    *
*          struct button_tag *b ;                    *
*  : ˣ                                    *
******************************************************
*    :                                           *
******************************************************
*/
make_button( s, b )
struct screen_tag *s ;
struct button_tag *b ;
{
    for( ; b->name != 0 ; b++ ) {
        draw_string( s, b->x, b->y+15, b->name );
    }

    XFlush( s->disp );

    return(0);
}

/* 
******************************************************
* ؿ̾ : get_button( s, b )                        *
* ǽ   : ޥˤܥ󲡲ΥåԤʤ  *
*    : struct screen_tag *s ;                    *
*          struct button_tag *b ;                    *
*  : ܥֹ                                *
******************************************************
*    :                                           *
******************************************************
*/
get_button( s, b ) 
struct screen_tag *s ;
struct button_tag *b ;
{
XEvent e ;
int    rtn ;

    for( ; ; ) {
	XCheckWindowEvent( s->disp, s->win, ButtonPressMask, &e );
        for( rtn = 0 ; b[rtn].name != 0 ; rtn++ ){
	    if( e.xbutton.x > b[rtn].x && e.xbutton.x < (b[rtn].x + b[rtn].w)&&
	        e.xbutton.y > b[rtn].y && e.xbutton.y < (b[rtn].y + b[rtn].h)) {
		return( rtn );
            }
	}
    }
}

/* 
******************************************************
* ؿ̾ : flush( s )                                *
* ǽ   : ̤ΥեåԤʤ                  *
*    : struct screen_tag *s ;                    *
*  : ˣ                                    *
******************************************************
*    :                                           *
******************************************************
*/
flush( s )
struct screen_tag *s ;
{
    XFlush( s->disp );

    return(0);
}

/* 
******************************************************
* ؿ̾ : draw_string( s, x, y, str )               *
* ǽ   : ʸʥޤˤ  *
*    : struct screen_tag *s ;                    *
*          int    x ;                                *
*          int    y ;                                *
*          char  *str ;                              *
*  : ˣ                                    *
******************************************************
*    :                                           *
******************************************************
*/
draw_string( s, x, y, str )
struct screen_tag *s ;
int     x, y;
unsigned char    *str;
{
int             i, j, k;
XChar2b         k_buff[2];

    k_buff[1].byte1 = 0;
    k_buff[1].byte2 = 0;
    for (i = 0, j = 0;;) {
        for (; str[i] != (unsigned char)NULL && !(str[i] & (unsigned char)0x80); i++, j++) {
            XDrawImageString( s->disp, s->win, s->gc_a,
                x + j * 7, y, &(str[i]), 1);
        }
        if (str[i] == (unsigned char)NULL) {
            break;
        }
        for (k = 0; str[i] != (unsigned char)NULL && (str[i] & 0x80); i++, j++) {
            if (k == 0) {
                k_buff[0].byte1 = (str[i] & 0x7f);
                k = 1;
            } else {
                k_buff[0].byte2 = (str[i] & 0x7f);
                k = 0;
                XDrawImageString16( s->disp, s->win, s->gc_k,
                    x + (j-1)*7, y, k_buff, 1);
            }
        }
        if (str[i] == (unsigned char)NULL) {
            break;
        }
    }

    return(0);
}

/* 
******************************************************
* ؿ̾ : put_bitmap( s, x, y, w, h, bit )          *
* ǽ   : ӥåȥޥåץѥ            *
*    : struct screen_tag *s ;                    *
*          int    x ;                                *
*          int    y ;                                *
*          int    w ;                                *
*          int    h ;                                *
*          Pixmap bit ;                              *
*  : ˣ                                    *
******************************************************
*    :                                           *
******************************************************
*/
put_bitmap( s, x, y, w, h, bit )
struct screen_tag *s ;
int    x ;
int    y ;
int    w ;
int    h ;
Pixmap bit ;
{
    XSetTSOrigin( s->disp, s->gc_a, x, y );
    XSetFillStyle( s->disp, s->gc_a, FillStippled );

    XSetStipple( s->disp, s->gc_a, bit );
    XFillRectangle( s->disp, s->win, s->gc_a, x, y, w, h );

    return(0);
}

/*********** end of file <win_com.c> ***********/
