/* 
******************************************************
* ե̾ : xpoker.c                              *
*                                                    *
* by ichikawa@landmark.fct.cs.fujitsu.co.jp          *
******************************************************
*/
#include "win_def.h"
#include <time.h>
#include <fcntl.h>
#include <errno.h>

#include "bitmaps/num_2"
#include "bitmaps/num_3"
#include "bitmaps/num_4"
#include "bitmaps/num_5"
#include "bitmaps/num_6"
#include "bitmaps/num_7"
#include "bitmaps/num_8"
#include "bitmaps/num_9"
#include "bitmaps/num_10"
#include "bitmaps/num_A"
#include "bitmaps/num_J"
#include "bitmaps/num_Q"
#include "bitmaps/num_K"
#include "bitmaps/mark_J"
#include "bitmaps/mark_S"
#include "bitmaps/mark_H"
#include "bitmaps/mark_K"
#include "bitmaps/mark_D"
#include "bitmaps/ura"
#include "bitmaps/mask"

struct screen_tag screen ;

char   path[80] ;

char   card[53] ; 

char   deal_card[5][2] ; 

char   hold_card[5] ; 

Pixmap mark[5] ; 
Pixmap num[13] ; 
Pixmap ura     ; 
Pixmap mask    ; 

int    Credit ;
int    Bet    ;
int    Win    ;

struct yaku_tag {
    int     num  ;
    char   *msg  ;
    int     odds ;
};

struct yaku_tag yaku[] = {
{  0, "Five Card ", 500 },
{  1, "R.S.Flush ", 100 },
{  2, "S.FLush   ", 70  },
{  3, "Four Card ", 50  },
{  4, "Full House", 20  },
{  5, "Flush     ", 15  },
{  6, "Straight  ", 10  },
{  7, "Three Card", 5   },
{  8, "Two Pair  ", 2   },
{ -1, 0, 0 }
};

/* 
******************************************************
* ؿ̾ : main()                                    *
* ǽ   : ᥤؿ                                *
*    : int    argc ;                             *
*          char  *argv[];                            *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
main( argc, argv )
int    argc ;
char   *argv[];
{

    if( argc != 2 ) {
	printf( "Usage : %s player-name \n", argv[0] );
	exit(1);
    }

    sprintf( path, "xpoker.%s.sv", argv[1] );

    printf( "%s V01/L02 \n", argv[0] );
    printf( "player file name : %s \n", path );

    screen.name = NULL ;	/* ǥץ쥤̾Σգ̣ */
    Credit = 50 ;		/*          */
    Bet    = 0 ;
    Win    = 0 ;

    load_dt();

    init_window( &screen );
    set_pixmap_data( &screen );

    game( &screen );

    if( Credit == 0 ) {
	printf( "****           ****\n" );
	printf( "**** Game Over ****\n" );
	printf( "****           ****\n" );
    }
}

/* 
******************************************************
* ؿ̾ : set_pixmap_data( s )                      *
* ǽ   : ԥޥåץǡΥå                *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
set_pixmap_data( s )
struct screen_tag *s ;
{
    mask   = set_bitmap( &screen , mask_bits,   mask_width,   mask_height );
    ura    = set_bitmap( &screen , ura_bits,    ura_width,    ura_height );

    num[0]  = set_bitmap( &screen , num_A_bits,  num_A_width,  num_A_height );
    num[1]  = set_bitmap( &screen , num_2_bits,  num_2_width,  num_2_height );
    num[2]  = set_bitmap( &screen , num_3_bits,  num_3_width,  num_3_height );
    num[3]  = set_bitmap( &screen , num_4_bits,  num_4_width,  num_4_height );
    num[4]  = set_bitmap( &screen , num_5_bits,  num_5_width,  num_5_height );
    num[5]  = set_bitmap( &screen , num_6_bits,  num_6_width,  num_6_height );
    num[6]  = set_bitmap( &screen , num_7_bits,  num_7_width,  num_7_height );
    num[7]  = set_bitmap( &screen , num_8_bits,  num_8_width,  num_8_height );
    num[8]  = set_bitmap( &screen , num_9_bits,  num_9_width,  num_9_height );
    num[9]  = set_bitmap( &screen , num_10_bits, num_10_width, num_10_height );
    num[10] = set_bitmap( &screen , num_J_bits,  num_J_width,  num_J_height );
    num[11] = set_bitmap( &screen , num_Q_bits,  num_Q_width,  num_Q_height );
    num[12] = set_bitmap( &screen , num_K_bits,  num_K_width,  num_K_height );

    mark[0] = set_bitmap( &screen , mark_J_bits, mark_J_width, mark_J_height );
    mark[1] = set_bitmap( &screen , mark_S_bits, mark_S_width, mark_S_height );
    mark[2] = set_bitmap( &screen , mark_H_bits, mark_H_width, mark_H_height );
    mark[3] = set_bitmap( &screen , mark_K_bits, mark_K_width, mark_K_height );
    mark[4] = set_bitmap( &screen , mark_D_bits, mark_D_width, mark_D_height );
}

/* 
******************************************************
* ؿ̾ : init_disp( s )                            *
* ǽ   : ɥν롼                *
*    : struct screen_tag *s ;                    *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
init_disp( s )
struct screen_tag *s ;
{
    XClearWindow( s->disp, s->win );

    disp_ura( s, 0 );
    disp_ura( s, 1 );
    disp_ura( s, 2 );
    disp_ura( s, 3 );
    disp_ura( s, 4 );

    disp_button_0( s );
    disp_button_2( s );
    disp_score( s );
}

/* 
******************************************************
* ؿ̾ : draw_yaku( s )                            *
* ǽ   : ɽ                                  *
*    : struct screen_tag *s :                    *
*          int    flag ;                             *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
draw_yaku( s, flag )
struct screen_tag *s ;
int    flag ;
{
int    i ;
char   wk[40];

    set_color_a( s, WIN_FG, "yellow" ); 

    for( i = 0 ; yaku[i].num != -1 ; i++ ) {
	if( flag == yaku[i].num ) {
	    sprintf( wk, "%-15s %-3d * %03d", yaku[i].msg, yaku[i].odds, Bet );
	    disp_msg( s, wk );
        }
    }
}

/* 
******************************************************
* ؿ̾ : disp_ura( s, pos )                        *
* ǽ   : ɤ΢¦ɽ                          *
*    : struct screen_tag *s ;                    *
*          int    pos ;                              *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
disp_ura( s, pos )
struct screen_tag *s ;
int    pos ;
{
    set_color_a( s, "white", "white" );
    put_bitmap( s, 16+32*pos, 32, 32, 32, mask );

    set_color_a( s, "red", "red" );
    put_bitmap( s, 16+32*pos, 32, 32, 32, ura );
}


/* 
******************************************************
* ؿ̾ : disp_card( s, pos, mark, num )            *
* ǽ   : ɤɽ¦ɽ                        *
*    : struct screen_tag *s ;                    *
*          int    pos ;                              *
*          int    m   ;                              *
*          int    n   ;                              *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
disp_card( s, pos, m, n )
struct screen_tag *s ;
int    pos ;
int    m ;
int    n ;
{

    set_color_a( s, "white", "white" );
    put_bitmap( s, 16+32*pos, 32, 32, 32, mask );

    switch( m ){	
    case    0 :		/* 硼 */
    case    1 :		/* ڡ   */
    case    3 : 	/*      */
	set_color_a( s, "black", "black" );	/*  */
        break;
    case    2 :		/* ϡ     */
    case    4 :		/*      */
	set_color_a( s, "red", "red" );
        break;
    }

    if( m != 0 )	/* 硼ʳʤ */
        put_bitmap( s, 16+32*pos, 32, 32, 32, num[ n ] );

    put_bitmap( s, 16+32*pos, 32, 32, 32, mark[ m ] );

}
/*
******************************************************
* ؿ̾ : disp_button_0( s )                        *
* ǽ   : ܥǡɽ                        *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
static struct button_tag button_0[5] = {
{ "[ Bet    ]", 110, 110, 70, 20 },
{ "[ Deal   ]", 110, 130, 70, 20 },
{ "[        ]", 110, 150, 70, 20 },
{ "[ End    ]", 110, 170, 70, 20 },
{ 0, 0, 0, 0, 0 }
};

disp_button_0( s )
struct screen_tag *s ;
{
    set_color_a( s, WIN_FG, WIN_BG );
    make_button( s, &button_0 );
}

/* 
******************************************************
* ؿ̾ : disp_button_1( s )                        *
* ǽ   : ܥǡɽ                        *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
static struct button_tag button_1[5] = {
{ "[ Bet    ]", 110, 110, 70, 20 },
{ "[ Deal   ]", 110, 130, 70, 20 },
{ "[ Double ]", 110, 150, 70, 20 },
{ "[ Take   ]", 110, 170, 70, 20 },
{ 0, 0, 0, 0, 0 }
};

disp_button_1( s )
struct screen_tag *s ;
{
    set_color_a( s, WIN_FG, WIN_BG );
    make_button( s, &button_1 );
}

/*
******************************************************
* ؿ̾ : disp_button_2( s )                        *
* ǽ   : ܥǡɽ                        *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*   ΰ hold_card[] ͤˤäơ              *
*      hold_card[] = 0 ʤ顡[ ]                     *
*      hold_card[] = 1 ʤ顡[H]                     *
******************************************************
*/
static struct button_tag button_2[7] = {
{ "[ ]", 16 + 32 * 0 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 1 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 2 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 3 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 4 + 5, 32 + 32 + 5, 28, 20 },
{ "[ Deal   ]", 110, 130, 70, 20 },
{ 0, 0, 0, 0, 0 }
};

static char button2_on[]  = "[H]";
static char button2_off[] = "[ ]";

disp_button_2( s )
struct screen_tag *s ;
{
int    i ;

    for( i = 0 ; i < 5 ; i++ ){
        if( hold_card[i] == 0 )
            button_2[i].name = button2_off ;
        else
            button_2[i].name = button2_on ;
    }
    
    set_color_a( s, WIN_FG, WIN_BG );
    make_button( s, &button_2 );
}

/* 
******************************************************
* ؿ̾ : disp_button_3( s )                        *
* ǽ   : ܥǡɽ                        *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*   ΰ hold_card[] ͤˤäơ              *
*      hold_card[] = 0 ʤ顡[S]                     *
*      hold_card[] = 1 ʤ顡[ ]                     *
******************************************************
*/
static struct button_tag button_3[6] = {
{ "[ ]", 16 + 32 * 1 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 2 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 3 + 5, 32 + 32 + 5, 28, 20 },
{ "[ ]", 16 + 32 * 4 + 5, 32 + 32 + 5, 28, 20 },
{ "[ Deal   ]", 110, 130, 70, 20 },
{ 0, 0, 0, 0, 0 } 
};

static char button3_on[]  = "[S]";
static char button3_off[] = "[ ]";

disp_button_3( s )
struct screen_tag *s ;
{
int    i ;

    for( i = 1 ; i < 5 ; i++ ){
	if( hold_card[i] == 1 )
	    button_3[i-1].name  = button3_off ;
        else
	    button_3[i-1].name  = button3_on ;
    }

    set_color_a( s, WIN_FG, WIN_BG );
    make_button( s, &button_3 );
}

/* 
******************************************************
* ؿ̾ : disp_score( s )                           *
* ǽ   : ɽ                              *
*    : struct screen_tag *s;                     *
*  : ʤ                                      *
******************************************************
*    :                                           *
*  Bet      ٥å                               *
*  Win                                       *
*  Credit   쥸å                               *
******************************************************
*/
disp_score( s )
struct screen_tag *s ;
{
char    wk[80];

    set_color_a( s, WIN_FG, WIN_BG );

    sprintf( wk, "BET    : %05d", Bet );
    draw_string( s, 7, 125, wk );

    sprintf( wk, "WIN    : %05d", Win);
    draw_string( s, 7, 145, wk );

    sprintf( wk, "Credit : %05d", Credit );
    draw_string( s, 7, 185, wk );

}

/* 
******************************************************
* ؿ̾ : disp_msg( s, msg )                        *
* ǽ   : åɽ                          *
*    : struct screen_tag *s ;                    *
*          char   *msg ;                             *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
disp_msg( s, msg )
struct screen_tag *s ;
char   *msg ;
{
    draw_string( s, 7, 20, msg );
    flush( s );
}


/* 
******************************************************
* ؿ̾ : get_rnd()                                 *
* ǽ   : ȯ                                *
*    : ʤ                                      *
*  : ͡ʣ                          *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
get_rnd()
{
long    tloc;
int     rt;

    tloc = time( (long *)0 );
    tloc = ((tloc & 0xff) * rand()) >> 3 ;
    rt = (int)(tloc & 0xffff);

    return( rt );
}

/* 
******************************************************
* ؿ̾ : game( s )                                 *
* ǽ   : ݡᥤ                        *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
game( s )
struct screen_tag *s ;
{
int    button;
int    yaku_num ; 

    while( Credit > 0 ) {	/* 쥸åȤ */
	Bet = 0 ;
	Win = 0 ;

	cls_table();		/* ơ֥Υꥢ */

        init_disp( s );		/* ɽν     */

        set_color_a( s, WIN_FG, WIN_BG );
        disp_msg( s, "Press Button, Bet or Deal" );
        flush( s );

        bet_coin( s );		/* Υ٥å */
	if( Bet == 0 ) {
	    save_dt();		/* ǡե˥ */
	    break;
	}

        set_color_a( s, WIN_FG, WIN_BG );
        disp_msg( s, "****** Good Luck !! *****" );
        flush( s );

        sleep( 1 );

        deal_card_op( s );	/* ǥ륫 */

        set_color_a( s, WIN_FG, WIN_BG );
        disp_msg( s, "Press Hold, When You Need" );
        flush( s );
	sleep( 1 );

	hold_card_op( s ); 	/* ۡɤ륫ɤ򤹤 */
	sleep( 1 );

        deal_card_op( s );	/* ۡɤʤäɤκƥǥ */

        yaku_num = check_yaku();	/* Ƚ */
	if( yaku_num == -1 ) {
	    set_color_a( s, "blue", WIN_BG );		/* ̣ϣӣ */
            disp_msg( s, "****** You Lost !! ******" );
	} else {
	    draw_yaku( s, yaku_num );			/* ףɣ   */
	    Win = Bet * yaku[ yaku_num ].odds ;
            disp_score( s ) ;
	}

        flush( s );
	sleep( 2 );

	if( Win != 0 ) {	/* ףɣΤʤ顡֥륢åץ */
	    double_up( s );
	}
    }

}

/* 
******************************************************
* ؿ̾ : cls_table()                               *
* ǽ   : ƥơ֥Υꥢ                        *
*    : ʤ                                      *
*  : ʤ                                      *
******************************************************
*    :                                           *
*  card      : ɥơ֥                        *
*  deal_card : ۤä                          *
*  hold_card : ۡɤ                    *
******************************************************
*/
cls_table( )
{
int    i ;
int    j ;

    for( i = 0 ; i < 53 ; i++ )
	    card[i] = -1 ;

    for( i = 0 ; i < 5 ; i++ )
	for( j = 0 ; j < 2 ; j++ )
	    deal_card[i][j] = -1 ;

    for( i = 0 ; i < 5 ; i++ )
	hold_card[i] = 0 ;
}

/* 
******************************************************
* ؿ̾ : bet_coin( s )                             *
* ǽ   : Υ٥å                            *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
bet_coin( s )
struct screen_tag *s ;
{
int    button ;
int    flag   ;

    flag = 0 ;
    do {
	button = get_button( s, &button_0 );
	switch( button ) {
	case    0 :		/* ǥܥ */
	    if( Credit > 0 ) {
		Bet   ++ ;
                Credit-- ;
	    }
	    disp_score( s );
	    flush( s );
	    break;
        case    1 :		/* ٥åȥܥ */
	    if( Bet != 0 ) 
		flag = 1 ;
            break;
        case    3 :		/* ɥܥ */
	    flag = 1 ;
            break;
	}

    } while( flag == 0 );

}

/* 
******************************************************
* ؿ̾ : deal_card_op( s )                         *
* ǽ   : ɤΥǥ                          *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
deal_card_op( s )
struct screen_tag *s ;
{
int    i ;
int    random ;

    for( i = 0 ; i < 5 ; i++ ) {
	if( hold_card[i] == 0 ) {	/* ۡɤƤʤʤ */
	    /* ȯ롣 */
	    do{
	        random = get_rnd() % 53 ; 
                if( card[ random ] == -1 )    break;

            } while( 1 );

	    card[ random ] = 1 ;	/* ɽиե饰 */

	    if( random == 52 ) {	/* 硼 */
		deal_card[i][0] = 0 ;
		deal_card[i][1] = 0 ;
            } else {
		deal_card[i][0] = (random / 13) + 1 ;    /* ޡη */
		deal_card[i][1] = ((random + 1) % 13) ;  /* η   */
	    }

	    /* ɤɽ */
	    disp_card( s, i, deal_card[i][0], deal_card[i][1] );
	}
    }
    flush( s );
}


/* 
******************************************************
* ؿ̾ : hold_card_op( s )                         *
* ǽ   : ۡɤ륫ɤ                  *
*    : struct screen_tag *s ;                    *
*  : ʤ                                      *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
hold_card_op( s )
struct screen_tag *s ;
{
int    button ;
int    i ;

    do {
	/* ۡɥɤ */
	button = get_button( s, &button_2 );
	if( button == 5 )    break;

	if( hold_card[button] == 0 ) 
	    hold_card[button] =  1 ;
        else 
	    hold_card[button] =  0 ;

        /* ܥκɽ */
        disp_button_2( s );
        flush( s );
    } while( 1 );


    for( i = 0 ; i < 5 ; i++ ) {
	if( hold_card[i] == 0 ) 	/* ۡɤʤɤʤ */
            disp_ura( s, i ) ;		/* ΢¦ɽ */
    }
    flush( s );
}

/* 
******************************************************
* ؿ̾ : check_yaku()                              *
* ǽ   : Ƚ                                  *
*    : ʤ                                      *
*  : ֹ                                    *
******************************************************
*    :                                           *
*     : ֹ                                 *
*   : ʤ                                 *
******************************************************
*/
check_yaku() 
{
int    f_flush    ;
int    f_joker    ;
int    f_j        ;
int    f_pair[2]  ;
int    pair[2]    ;
int    f_straight ;
int    f_royal    ;
int    i ;

    f_joker = sort_card() ;	/* ɤΥ */

    /* flush check */
    /* f_flush - ޡƱΥɤ         */
    /*           硼ϡͤ */

    f_flush = f_joker ;
    for( i = f_joker ; i < 4 ; i++ ) {
	if( deal_card[i][0] == deal_card[i+1][0] ) {	/* ޡƱʤ */
	    f_flush ++ ;
	} else {
	    break;
	}
    }
    /* printf( "f_flush = %d \n", f_flush ); */

    /* straight check */
    f_straight = 0 ;
    f_royal    = 0 ;
    f_j        = f_joker ;

    for( i = f_joker ; i < 4 ; i++ ) {

	/* ΥɤοΥɡܣ */

	if( (deal_card[i][1] + 1) == deal_card[i+1][1] ) { 
	    f_straight ++ ;
	} else {

	    /* Υɤܣǡ硼뤫 */

	    if( ((deal_card[i][1] + 2) == deal_card[i+1][1])&&(f_j == 1) ) {
                f_straight += 2 ;
                i++ ;
		f_j = 0 ;
	    } else {
		break;
	    }
	}
    } 
    if( f_straight == 3 )
        f_straight += f_j ;

    if( f_straight == 4 ) {
	if( (deal_card[f_joker][1] == 9)||(deal_card[f_joker][1] == 10))
	    f_royal = 1 ;
    }

    /* printf( "f_straight = %d \n", f_straight ); */
    /* printf( "f_royal    = %d \n", f_royal    ); */


    /* pair check */
    f_pair[0]  = -1 ;
    f_pair[1]  = -1 ;
    pair[0] = -1 ;
    pair[1] = -1 ;

    for( i = f_joker ; i < 4 ; i++ ) {
	if( deal_card[i][1] == deal_card[i+1][1] ) {
	    if( pair[0] == -1 ) {
		pair[0] = deal_card[i+1][1] ;
		f_pair[0] = 2 ;
	    } else {
		if( pair[0] == deal_card[i+1][1] ){
		    f_pair[0] ++ ;
		} else {
		    if( pair[1] == -1 ) {
		        pair[1] = deal_card[i+1][1] ;
		        f_pair[1] = 2 ;
		    } else {
			f_pair[1] ++ ;
		    }
		}
            }
	}
    }
    f_pair[0] += f_joker ;

    /* printf( "f_pair[0] = %d : pair[0] = %-2d \n", f_pair[0], pair[0] ); */
    /* printf( "f_pair[1] = %d : pair[1] = %-2d \n", f_pair[1], pair[1] ); */


    if( f_pair[0] == 4 && f_joker == 1 ) {
	return( 0 ) ;
    }

    if( f_royal == 1 && f_straight == 4 && f_flush == 4 ) {
	return( 1 ) ;
    }

    if( f_straight == 4 && f_flush == 4 ) {
	return( 2 ) ;
    }

    if( f_pair[0] == 4 ) {
	return( 3 ) ;
    }

    if(((f_pair[0] == 3)&&(f_pair[1] == 2))||
       ((f_pair[0] == 2)&&(f_pair[1] == 3))) {
        return( 4 ) ;
    }

    if( f_flush == 4 ) {
        return( 5 ) ;
    }

    if( f_straight == 4 ) {
        return( 6 ) ;
    }

    if( f_pair[0] == 3 ) {
        return( 7 ) ;
    }
    if( (f_pair[0] == 2 )&&(f_pair[1] == 2) ) {
        return( 8 ) ;
    }

    return( -1 ) ;
}

/* 
******************************************************
* ؿ̾ : sort_card()                               *
* ǽ   :                                           *
*    :                                           *
*                                                    *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
sort_card()
{
char    wk_m, wk_n ;
int     joker ;
int     i, j ;

    joker = 0 ; 
    for( i = 0 ; i < 5 ; i++ ) {
	if( deal_card[i][0] == 0 ) {	/* joker */
	    wk_m = deal_card[0][0] ;
	    wk_n = deal_card[0][1] ;
	    deal_card[0][0] = deal_card[i][0] ;
	    deal_card[0][1] = deal_card[i][1] ;
	    deal_card[i][0] = wk_m ; 
	    deal_card[i][1] = wk_n ;
	    joker = 1 ;
	    break;
	}
    }

    for( i = 0 ; i < 5 ; i++ ) {
	if( deal_card[i][1] == 0 ) {
	    deal_card[i][1] = 13 ;		/* A */
	}
    }

    /* printf( "sort_card() : joker = %d \n" , joker ) ; */

    for( i = joker ; i < 4 ; i++ ) {
	for( j = i ; j < 5 ; j++ ) {
	    if( deal_card[i][1] > deal_card[j][1] ) {
	        wk_m = deal_card[j][0] ;
	        wk_n = deal_card[j][1] ;
	        deal_card[j][0] = deal_card[i][0] ;
	        deal_card[j][1] = deal_card[i][1] ;
	        deal_card[i][0] = wk_m ; 
	        deal_card[i][1] = wk_n ;
	    }
	}
    }

    return( joker );
}

/* 
******************************************************
* ؿ̾ : double_up( s )                            *
* ǽ   :                                           *
*    :                                           *
*                                                    *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
double_up( s )
struct screen_tag *s ;
{
int    button ;

    do {
        disp_button_1( s );
        disp_score( s );

        set_color_a( s, WIN_FG, WIN_BG );
        disp_msg( s, " Double Up or Take Score " );
        flush( s );
	sleep( 1 );

        button = get_button( s, &button_1 );
        if( button == 3 ) {
	    Credit += Win ;
            break;
	}
	if( button == 2 ) {
	    double_up_game( s );
	}
	if( Win == 0 ) {
	    break ;
	}

    } while( 1 );

}

/* 
******************************************************
* ؿ̾ : double_up_game( s )                       *
* ǽ   :                                           *
*    :                                           *
*                                                    *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
double_up_game( s )
struct screen_tag *s ;
{
int    button ;
int    flag   ;

    cls_table();

    XClearWindow( s->disp, s->win );

    disp_ura( s, 0 );
    disp_ura( s, 1 );
    disp_ura( s, 2 );
    disp_ura( s, 3 );
    disp_ura( s, 4 );

    disp_button_1( s );
    disp_button_3( s );
    disp_score( s );

    hold_card[1] = 1 ;
    hold_card[2] = 1 ;
    hold_card[3] = 1 ;
    hold_card[4] = 1 ;

re_deal:
    deal_card_op( s ); 
    if( deal_card[0][0] == 0 ) {	/* joker */
        set_color_a( s, WIN_FG, "yellow" );
        disp_msg( s, "***** Luckey Win !! *****" );
        Win = Win * 3 ;
        flush( s );
        sleep( 1 );
	return(0);
    }
    if( deal_card[0][1] == 0 ) {	/* Ace */
	hold_card[0] = 0 ;
	goto re_deal ;
    }

    set_color_a( s, WIN_FG, WIN_BG );
    disp_msg( s, "Select Bigger 1 Card     " );
    disp_button_3( s );
    flush( s );
    sleep( 1 );

    flag = -1 ;
    do {
        button = get_button( s, &button_3 );
        if( button == 4 && flag != -1 ) {
	    break; 
	}

        hold_card[0] = 1 ;
        hold_card[1] = 1 ;
        hold_card[2] = 1 ;
        hold_card[3] = 1 ;
        hold_card[4] = 1 ;
	flag = button + 1 ;
        hold_card[flag] = 0 ;

	disp_button_3( s );

    } while( 1 );

    hold_card[0] = 1 ;
    hold_card[1] = 0 ;
    hold_card[2] = 0 ;
    hold_card[3] = 0 ;
    hold_card[4] = 0 ;

    deal_card_op( s );
    sleep(2);

    /* printf( "deal_card[0][1] = %d \n", deal_card[0][1] ); */
    /* printf( "deal_card[%d][1] = %d \n", flag ,deal_card[flag][1] ); */
    if( deal_card[flag][1] == 0 ){
	deal_card[flag][1] = 13 ;
    }
    if( deal_card[flag][0] == 0 ) {	/* joker */
	deal_card[flag][1] = 14 ;
    }

    if( deal_card[0][1] > deal_card[flag][1] ) {
	set_color_a( s, "blue", WIN_BG );
        disp_msg( s, "****** You Lost !! ******" );
	Win = 0 ;
        flush( s );
        sleep( 1 );
    } else {
        set_color_a( s, WIN_FG, "yellow" );
        disp_msg( s, "****** You Win  !! ******" );
	Win = Win * 2 ;
        flush( s );
        sleep( 1 );
    }
}

/* 
******************************************************
* ؿ̾ : load_dt()                                 *
* ǽ   :                                           *
*    :                                           *
*                                                    *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
load_dt()
{
int    fildes ;
int    cc ;

    fildes = open( path, O_RDONLY );
    if( fildes == -1 && errno == ENOENT ){
	return( 0 );
    }
    if( fildes == -1 && errno != ENOENT ){
	printf( "file < %s > open error \n", path );
	exit(1);
    }
    
    cc = read( fildes, &Credit, sizeof( int ) ) ;
    if( cc != sizeof( int ) ) {
	printf( "file < %s > read error \n", path );
	exit(1);
    }

    close( fildes );

    if( Credit == 0 ) {
	Credit =  50 ;
    }
}

/* 
******************************************************
* ؿ̾ : save_dt()                                 *
* ǽ   :                                           *
*    :                                           *
*                                                    *
*  :                                           *
*                                                    *
******************************************************
*    :                                           *
*                                                    *
******************************************************
*/
save_dt()
{
int    fildes ; 
int    cc     ;

    fildes = open( path,  O_RDWR | O_CREAT | O_TRUNC, 0666 );
    if( fildes == -1 ) {
	printf( "file < %s > open error \n" , path );
	exit(1);
    }

    cc = write( fildes, &Credit, sizeof( int ) );
    if( cc != sizeof( int ) ) {
        printf( "file < %s > save error \n", path );
        exit(1);
    }

    close( fildes ) ;
}
